package cl.firefox.pcollaog.velocity;

import java.io.StringWriter;
import java.io.Writer;
import java.util.Properties;

import org.apache.log4j.Logger;
import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.Velocity;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

/**
 * <p>
 * </p>
 * <p>
 * $Id: VelocityEngine.java,v 1.1 2009-04-20 00:21:20 pcollaog Exp $
 * </p>
 * 
 * @author pcollaog
 * @version $Revision: 1.1 $
 */
public class VelocityEngine {

	Logger logger = Logger.getLogger(VelocityEngine.class);

	private VelocityContext _ctx;

	private void init() throws Exception {
		logger.info("Inicializando Velocity");
		Properties prop = new Properties();

		// Carga archivo de propiedades de velocity
		prop.load(getClass()
				.getResourceAsStream("/velocity.properties"));

		// Inicializa Velocity
		Velocity.init(prop);

		_ctx = new VelocityContext();
	}

	public String mergeTemplate() throws ResourceNotFoundException,
			ParseErrorException, Exception {

		init();

		// Carga el template
		Template tpl = Velocity.getTemplate("template.vm");

		// Agrega una variable al contexto luego puede ser usada
		// como $salida
		_ctx.put("salida", "OK");

		// Creo un Writer para almacenar la salida
		Writer writer = new StringWriter();

		// Genero la mezcla del template con sus las variables
		// del contexto y macros de velocity
		tpl.merge(_ctx, writer);

		// Finalmente genero un string con la salida
		return writer.toString();
	}
}
